/*
  Version 5 fentes, donc 10 interruptions


*/
#define ENCODER_USE_INTERRUPTS
#define ENCODER_OPTIMIZE_INTERRUPTS
#include <Encoder.h>
Encoder CompteurBroche(0, 1); //capteur compte-tours
int DiamLeft  = -999;
int newLeft = 0;
int DiamRight  = -999;
int newRight = 0;
int Diametre = 0;
int RazCptValue = 1;
int AvanceRapide = 1;
int VitesseAvance = 0;
Encoder knobLeft(A0, A1); // bouton DIAM dizaines
Encoder knobRight(A2, A3); //bouton DIAM unites

#include <Wire.h>  // Comes with Arduino IDE

#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3F, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address


static char outstr[15];
long positionCompteur = 0L;
long newCompteur = 0L;
long Compteur = 0L;
int Occ = 0;

void setup() {
  lcd.begin(16, 2);  // initialize the lcd for 16 chars 2 lines, turn on backlight
  lcd.clear();
  lcd.setCursor(0, 0); //Start at character 0 on line 0
  lcd.print("Tours       Diam");

  pinMode(5, OUTPUT); //broche 5 pour sortie STEP
  pinMode(A5, INPUT); //broche A5 pour lecture POT
  pinMode(8, INPUT); // broche 8 bouton poussoir Avance Rapide
  pinMode(12, INPUT); // broche 12 bouton poussoir RAZ compteur
}


void loop() {
  //    Logs pour suivi des temps d'éxécution
  //    Serial.print(micros());
  //    Serial.print("    ");
  //    Serial.print(Occ);
  //    Serial.print("    ");
  //    Serial.println(newCompteur/2);

  // on surveille surtout le Compteur BROCHE (sur Pins Interrupt capable)
  newCompteur = CompteurBroche.read();
  if (newCompteur != positionCompteur) {   // nouvelle interruption
    positionCompteur = newCompteur;
    Occ = newCompteur % 4      ;       // 20 modulo 5 = 5 séries par tour
    if (Occ == 0) {                    // à la fin de la periode (cinquieme de tour), avance de diametre*5
      Salve(Diametre * 5);          // voir la feulle XL PULSES pour calculs
    }
  }                                  // fin de l'événement avance BROCHE

  //on surveille aussi la mise à jour du DIAM
  newLeft = knobLeft.read();
  newRight = knobRight.read();
  if (newLeft != DiamLeft | newRight != DiamRight) {
    DiamLeft = newLeft;
    DiamRight = newRight;
    Diametre = (DiamLeft * 10) + (DiamRight);
    lcd.setCursor(12, 1); // maj affichage diametre uniquement s'il a change
    lcd.print("     ");
    lcd.setCursor(12, 1);
    lcd.print(Diametre);
  }                    // fin de l'événement changement DIAM

  // Evénement Avance Rapide
  AvanceRapide = digitalRead(8); //
  if (AvanceRapide < 1) {
    VitesseAvance = analogRead(A5);   //lecture du POT pour vitesse avance
    Salve(VitesseAvance);             //
  }                        // fin de l'événement AvanceRapide

  // Evénement RAZ Compteur
  RazCptValue = digitalRead(12);
  if (RazCptValue < 1) {
    CompteurBroche.write(0);
    lcd.print("       ");  //effacement de tous les caractères jusque -999.9
  } // fin de l'événement RAZ Compteur

  // Mise à jour des Affichages
  dtostrf(newCompteur / 20, 4, 0, outstr);
  lcd.setCursor(0, 1);
  lcd.print(outstr);

}  // fin de LOOP


void Salve(int param1) {              // fonction Salve qui envoie les steps au moteur sur Pin 5
  for (int compteur = 0; compteur < param1; compteur++)
  {
    digitalWrite(5, LOW);
    delayMicroseconds(50);           //100 microsecondes au total (50 LOW 50 HIGH) semble le plancher
    digitalWrite(5, HIGH);
    delayMicroseconds(50);
  }
}





